<?php

class PerfectmoneyPaymentModuleFrontController extends ModuleFrontController
{
    
        public $templateName = 'module:perfectmoney/views/templates/front/payment_form.tpl';    
        public $ssl = true;

	/**
	 * @see FrontController::initContent()
	 */
	public function initContent()
	{
                parent::initContent();
                
		$cart = $this->context->cart;
                $customer = new Customer($cart->id_customer);
                $order_currency = new Currency($cart->id_currency);
                $currency=$order_currency->iso_code;
                $cart_total=Tools::displayPrice($cart->getOrderTotal(true, Cart::BOTH));
                $total=str_replace($order_currency->symbol, '' , $cart_total);
                
                if ($currency!='USD' && $currency!='EUR' )
			Tools::redirect('index.php?controller=order');
                
                
                $this->module->validateOrder(
                    $cart->id,
                    _PS_OS_PREPARATION_,
                    $total,
                    $this->module->displayName,
                    null,
                    [],
                    $order_currency->id,
                    false,
                    $customer->secure_key
                );
                
                $payment_url=Tools::getShopDomainSsl(true).
                    '/index.php?controller=order-confirmation'.
                    '&id_cart='.$cart->id.
                    '&id_module='.(int)$this->module->id.
                    '&key='.$customer->secure_key;
                
                $this->context->smarty->assign(array(
                        'PAYEE_ACCOUNT' => Configuration::get('PERFECTMONEY_ACCOUNT'),
			'PAYEE_NAME' => Configuration::get('PERFECTMONEY_NAME'),
			'PAYMENT_AMOUNT' => $total,
			'PAYMENT_UNITS' => $currency,
			'STATUS_URL' => Tools::getShopDomainSsl(true).'/modules/perfectmoney/validation.php',
			'PAYMENT_ID' => $this->module->currentOrder,
			'PAYMENT_URL' => $payment_url,
			'NOPAYMENT_URL' => Tools::getShopDomainSsl(true).'/module/perfectmoney/error'
		));

		$this->setTemplate($this->templateName);
                
	}
        
}

?>