<?php

use PrestaShop\PrestaShop\Adapter\Presenter\Order\OrderPresenter;

include(dirname(__FILE__) . '/../../config/config.inc.php');

// load PrestaShop kernel
require_once _PS_ROOT_DIR_ . '/app/AppKernel.php';
$kernel = new \AppKernel('prod', false);
$kernel->boot();

include(dirname(__FILE__) . '/perfectmoney.php');

if (!isset($_POST['PAYMENT_ID']) || !is_numeric($_POST['PAYMENT_ID'])) exit;

$order_obj = new Order((int) $_POST['PAYMENT_ID'], Context::getContext()->language->id);

if (!Validate::isLoadedObject($order_obj)) exit;

$order_details = (new OrderPresenter())->present($order_obj);

$order_currency = new Currency($order_obj->id_currency);

if (!Validate::isLoadedObject($order_currency)) exit;

$amount = str_replace($order_currency->symbol, '', $order_details['totals']['total']['value']); // order amount

$currency = $order_currency->iso_code;  // order currency

$perfectmoney = new Perfectmoney();

define('ALTERNATE_PHRASE_HASH', strtoupper(md5(Configuration::get('PERFECTMONEY_PASSPHRASE'))));

$string =
        $_POST['PAYMENT_ID'] . ':' . $_POST['PAYEE_ACCOUNT'] . ':' .
        $_POST['PAYMENT_AMOUNT'] . ':' . $_POST['PAYMENT_UNITS'] . ':' .
        $_POST['PAYMENT_BATCH_NUM'] . ':' .
        $_POST['PAYER_ACCOUNT'] . ':' . ALTERNATE_PHRASE_HASH . ':' .
        $_POST['TIMESTAMPGMT'];

$hash = strtoupper(md5($string));

if ($hash == $_POST['V2_HASH']) {

    if ($currency != 'USD' && $currency != 'EUR'){
        $perfectmoney->changeOrderStatus($order_obj, _PS_OS_ERROR, $order_currency, 'wrong currency');
        exit;
    }

    if ($currency != $_POST['PAYMENT_UNITS']){
        $perfectmoney->changeOrderStatus($order_obj, _PS_OS_ERROR_, $order_currency, 'currency does not match');
        exit;
    }

    $account = Configuration::get('PERFECTMONEY_ACCOUNT');

    if ($_POST['PAYEE_ACCOUNT'] == $account && $_POST['PAYMENT_AMOUNT'] == $amount) {
        $perfectmoney->changeOrderStatus($order_obj, _PS_OS_PAYMENT_, $order_currency);
    } else {
        $perfectmoney->changeOrderStatus($order_obj, _PS_OS_ERROR_, $order_currency, 'amount does not match');
    }
    
} else {

    $perfectmoney->changeOrderStatus($order_obj, _PS_OS_ERROR_, $order_currency, 'wrong hash');
}

?>